local _, CCD = ...

CCD.Allies = CCD.Allies or {}
local Allies = CCD.Allies
CCD.Ally = CCD.Ally or {}
local Ally = CCD.Ally
CCD.Modules.RBT = CCD.Modules.RBT or {}
local RBT = CCD.Modules.RBT
CCD.Me = CCD.Me or {}
CCD.Modules.CPT = CCD.Modules.CPT or {}
local CPT = CCD.Modules.CPT
CCD.Debug = CCD.Debug or {}
local Debug = CCD.Debug

CCD.Allies.ValuesById = {}
CCD.Allies.Ids = {}
CCD.Allies.Count = 0

function Allies:Add(Ally)
	if self:Get(UnitId) then error("Attempted to add duplicate Ally.") end
	if not Ally then error("Attempted to add nil to Allies.") end
	
	self.ValuesById[Ally.Id] = Ally
	table.insert(self.Ids, Ally.Id)
	self.Count = self.Count + 1
	Allies:OnCountChanged()

	Debug:Record("New group member being tracker: %s (Id: %s)", Ally.Name, Ally.Id)
end
function Allies:AddSelf()
	CCD.Me = CCD.Ally:Create("player")
	CCD.Me.Id = Inspect.Unit.Lookup(CCD.Me.Id)
	function CCD.Me:GetInventory()
		return Inspect.Item.List(Utility.Item.Slot.Inventory())
	end
	
	self.ValuesById[CCD.Me.Id] = CCD.Me
	table.insert(self.Ids, CCD.Me.Id)
	self.Count = self.Count + 1
	Allies:OnCountChanged()

	Debug:Record("Now tracking: %s (Id: %s)", CCD.Me.Name, CCD.Me.Id)
end
function Allies:Remove(UnitId)
	local name = Allies.ValuesById[UnitId].Name
	local ally = Allies.ValuesById[UnitId]
	
	self.ValuesById[UnitId] = nil -- then remove the player from Allies.ValuesById
	
	for i in ipairs(self.Ids) do
		if Allies.Ids[i] == UnitId then
			table.remove(Allies.Ids, i)
			break
		end
	end
	
	self.Count = self.Count - 1
	Allies:OnCountChanged()
	
	Debug:Record("%s has been removed.", name)
end
function Allies:OnCountChanged()
	if CCD.Modules.RCT.OnAllyCountChanged then CCD.Modules.RCT:OnAllyCountChanged() end
	if CCD.Modules.RBT.OnAllyCountChanged then CCD.Modules.RBT:OnAllyCountChanged() end
	if CCD.Modules.CPT.OnAllyCountChanged then CCD.Modules.CPT:OnAllyCountChanged() end
end
function Allies:Get(UnitId)
	return self.ValuesById[UnitId]
end