local _, CCD = ...

CCD.Buff = CCD.Buff or {}
function CCD.Buff:Create(UnitId, BuffId)
	local buff = {}
	setmetatable(buff, self)
	self.__index = self

	local details = Inspect.Buff.Detail(UnitId, BuffId)
	buff.Id = details.id
	buff.Type = details.type or details.rune
	buff.Name = details.name
	buff.Icon = details.icon
	buff.Stacks = details.stack
	buff.CasterId = details.caster
	buff.TargetId = UnitId -- Removed in 3.3.0 to make Buff:Create more flexible; No usage of Buff.Target was found
	buff.StartTime = details.begin
	--if not buff.StartTime then CCD.Modules.ErrorManager.AddError("CCD.Buff:Create", "No .begin for " .. buff.Name) end
	buff.Duration = details.duration
	buff.Remaining = details.remaining
	buff.Rune = details.rune
	buff.Description = details.description

	return buff
end
function CCD.Buff:Delete()
	
end