local TOC, CCD = ...
CCD.UI = CCD.UI or {}

function CCD.UI.CreateCheckbox(Name, Parent, Checked)
	local checkbox = UI.CreateFrame("SimpleCheckbox", Name, Parent)

	checkbox.label:SetWordwrap(true)
	checkbox.label:SetEffectGlow(CCD.UI.DefaultTextEffectGlow)
	if Checked ~= nil then checkbox:SetChecked(Checked) end
	checkbox:SetVisible(true)

	checkbox.BaseSetText = checkbox.SetText
	function checkbox:SetText(Text, Size, Color)
		checkbox:BaseSetText(Text)
		if Size then checkbox:SetFontSize(Size) end
		if Color then checkbox:SetFontColor(Color.R, Color.G, Color.B, Color.A) end
	end
	
	checkbox.BaseSetWidth = checkbox.SetWidth
	function checkbox:SetWidth(Width)
		checkbox:BaseSetWidth(Width)
		checkbox.label:SetWidth(Width - checkbox.check:GetWidth())
	end
	
	checkbox.BaseSetBackgroundColor = checkbox.SetBackgroundColor
	function checkbox:SetBackgroundColor(Color, Green, Blue, Alpha)
		if Green then
			checkbox:BaseSetBackgroundColor(Color, Green, Blue, Alpha or 1)
		else
			checkbox:BaseSetBackgroundColor(Color.R, Color.G, Color.B, Color.A)
		end
	end
	
	checkbox.BaseSetFontColor = checkbox.SetFontColor
	function checkbox:SetFontColor(Color, Green, Blue, Alpha)
		if Green then
			checkbox:BaseSetFontColor(Color, Green, Blue, Alpha or 1)
		else
			checkbox:BaseSetFontColor(Color.R, Color.G, Color.B, Color.A)
		end
	end

	return checkbox
end
