local TOC, CCD = ...

CCD.UI = CCD.UI or {}

CCD.UI.Color = {
	R,
	G,
	B,
	A
}

-- Aliases
local Color = CCD.UI.Color

function Color:Create(R, G, B, A) -- Also accepts Color:Create(OtherColor)
	local color = {}
	setmetatable(color, self)
	self.__index = self

	if not G and not B and not A then
		color.R = R.R
		color.G = R.G
		color.B = R.B
		color.A = R.A
	else
		color.R = R
		color.G = G
		color.B = B
		color.A = A or 1
	end
	
	return color
end
function Color.White()
	return Color:Create(1, 1, 1, 1)
end
function Color.Red()
	return Color:Create(1, 0, 0, 1)
end
function Color.Yellow()
	return Color:Create(1, 1, 0, 1)
end
function Color.Green()
	return Color:Create(0, 1, 0, 1)
end
function Color.Black(Alpha)
	return Color:Create(0, 0, 0, Alpha or 1)
end
function Color.BlackTint()
	return Color:Create(0, 0, 0, 0.5)
end

function Color.Orange()
	return Color:Create(1, 0.5, 0, 1)
end
function Color.Grey(Alpha)
	return Color:Create(0.5, 0.5, 0.5, Alpha or 1)
end
function Color.Purple(Alpha)
	return Color:Create(0.5, 0, 1, Alpha or 1)
end

CCD.UI.Colors = {
	White = Color:Create(1, 1, 1),
	Black = Color:Create(0, 0, 0, 1),
	Red = Color:Create(1, 0, 0),
	Green = Color:Create(0, 1, 0),
	Blue = Color:Create(0, 0, 1),
	Yellow = Color:Create(1, 1, 0),
	Orange = Color:Create(1, 0.5, 0),
	HeavyBlackTint = Color:Create(0, 0, 0, 0.85),
	BlackTint = Color:Create(0, 0, 0, 0.5),
	ForegroundTint = Color:Create(1, 1, 1, 0.25),
	LightRedTint = Color:Create(1, 0, 0, 0.25),
	Turquoise = Color:Create(0, 1, 1, 1),
	ForegroundBlackTint = Color:Create(0, 0, 0, 0.70),
}