local TOC, CCD = ...

CCD.UI = CCD.UI or {}
CCD.UI.Context = CCD.UI.Context or UI.CreateContext("CCDContext")
CCD.UI.Colors = CCD.UI.Colors or {}

-- Aliases
local Colors = CCD.UI.Colors

function CCD.UI.CreateColorBar(Id, Parent, Color)
	local outerContainer = CCD.UI.CreateFrame(Id .. "(Outer)", Parent)
	outerContainer:SetBackgroundColor(CCD.UI.Colors.Black)
	
	local innerContainer = CCD.UI.CreateFrame(Id, outerContainer)
	--Library.LibSimpleWidgets.SetBorder("plain", innerContainer, 2, 1, 0, 0, 1, "tblr") -- thin black border
	--innerContainer:SetBackgroundColor(CCD.UI.Colors.Black)
	innerContainer:SetPoint("CENTER", outerContainer, "CENTER")

	function outerContainer.Event:Size()
		innerContainer:SetSize(self:GetWidth() -2, self:GetHeight() -2)
		innerContainer.Icon:SetSize(innerContainer:GetHeight())
		innerContainer.Filling:SetSize(innerContainer:GetWidth() - innerContainer.Icon:GetWidth(), innerContainer:GetHeight())
		--innerContainer.Filling:SetHeight(innerContainer:GetHeight())
		innerContainer.Filling.MaxWidth = innerContainer.Filling:GetWidth()
		self:SetPercentage()		
	end
	
	innerContainer.FontSize = 18
	innerContainer.FillPercentage = 0
	
	innerContainer.Icon = CCD.UI.CreateTexture(Id .. ".Icon", innerContainer)
	innerContainer.Icon:SetSize(24)
	innerContainer.Icon:SetPoint("TOPLEFT", innerContainer, "TOPLEFT")	
	
	innerContainer.Filling = CCD.UI.CreateFrame(Id .. ".Filling", innerContainer)
	innerContainer.Filling:SetBackgroundColor(Color.R, Color.G, Color.B, Color.A)
	innerContainer.Filling:SetPoint("TOPLEFT", innerContainer.Icon, "TOPRIGHT")
		
	innerContainer.Title = CCD.UI.CreateText(Id .. ".Title", innerContainer)
	innerContainer.Title:SetLayer(2) -- on top of Filling
	innerContainer.Title:SetText("Title", innerContainer.FontSize, Colors.White)
	innerContainer.Title:SetEffectGlow(CCD.UI.DefaultTextEffectGlow)
	innerContainer.Title:SetWordwrap(false)
	innerContainer.Title:SetPoint("LEFT", innerContainer.Icon, "RIGHT")
	innerContainer.Title:SetPoint("CENTER", innerContainer, "CENTER")
	
	innerContainer.TimerText = CCD.UI.CreateText(Id .. ".TimerText", innerContainer)
	innerContainer.TimerText:SetLayer(2) -- on top of Filling
	innerContainer.TimerText:SetText("100", innerContainer.FontSize, Colors.White)
	innerContainer.TimerText:SetEffectGlow(CCD.UI.DefaultTextEffectGlow)
	--innerContainer.TimerText:SetPoint("TOPRIGHT", innerContainer, "TOPRIGHT")
	innerContainer.TimerText:SetPoint("RIGHTCENTER", innerContainer, "RIGHTCENTER")
	
	--innerContainer.TimerText:SetPoint("RIGHT", innerContainer, "RIGHT")
	
	function outerContainer:SetPercentage(Percentage)
		innerContainer.FillPercentage = Percentage or innerContainer.FillPercentage
		innerContainer.Filling:SetWidth(innerContainer.FillPercentage / 100 * innerContainer.Filling.MaxWidth)
	end
	function outerContainer:SetTexture(Source, File)
		innerContainer.Icon:SetTexture(Source, File)
	end
	function outerContainer:SetColor(Color, Alpha)
		innerContainer.Filling:SetBackgroundColor(Color.R, Color.G, Color.B, Alpha or Color.A)		
	end
	function outerContainer:SetTitle(Text)
		innerContainer.Title:SetText(Text)
	end
	function outerContainer:SetTimerText(Text)
		innerContainer.TimerText:SetText(Text)
	end
	function outerContainer:SetFontSize(FontSize)
		innerContainer.Title:SetFontSize(FontSize)
		innerContainer.TimerText:SetFontSize(FontSize)
		innerContainer.FontSize = FontSize
	end
	
	outerContainer.Icon = innerContainer.Icon	
	outerContainer.Filling = innerContainer.Filling
	outerContainer.TimerText = innerContainer.TimerText
	
	return outerContainer
end