local TOC, CCD = ...
CCD.UI = CCD.UI or {}

function CCD.UI.CreateFrame(Name, Parent, BackgroundColor, Width, Height)
	local frame = UI.CreateFrame("Frame", Name, Parent)
	
	if BackgroundColor then frame:SetBackgroundColor(BackgroundColor.R, BackgroundColor.G, BackgroundColor.B, BackgroundColor.A) end
	if Width then frame:SetWidth(Width) end
	if Height then frame:SetHeight(Height) end
	
	function frame:SetSize(W, H)
		self:SetWidth(W)
		self:SetHeight(H or W)
	end
	function frame:Hide()
		frame:SetVisible(false)
	end
	function frame:Show()
		frame:SetVisible(true)
	end
	local BaseSetBackgroundColor = frame.SetBackgroundColor
	function frame:SetBackgroundColor(Color, G, B, A)
		if not G then
			BaseSetBackgroundColor(self, Color.R, Color.G, Color.B, Color.A)
		else
			BaseSetBackgroundColor(self, Color, G, B, A)
		end
	end
	function frame:SetBackgroundAlpha(Alpha)
		local r, g, b, a = self:GetBackgroundColor()
		BaseSetBackgroundColor(self, r, g, b, Alpha)
	end
	
	return frame
end