local TOC, CCD = ...
CCD.UI = CCD.UI or {}

function CCD.UI.CreateSlider(Name, Parent, Label)
	-- Container
	local container = CCD.UI.CreateFrame(Name, Parent)
	container.SliderXOffset = 0	
	--Library.LibSimpleWidgets.SetBorder("plain", container, 1, 1, 1, 1, 1, "tblr")
	
	-- Label
	container.Label = CCD.UI.CreateText(Name .. ".Label", container)
	container.Label:SetPoint("TOPLEFT", container, "TOPLEFT")
	function container.Label.Event:Size()
		container:Resize()
	end

	-- Slider
	container.Slider = UI.CreateFrame("SimpleSlider", Name .. ".Slider", container)
	container.Slider:SetPoint("TOPLEFT", container.Label, "TOPRIGHT", container.SliderXOffset, 0)
	function container.Slider.Event:Size()
		container:Resize()
	end
	
	function container:SetRange(Min, Max, Current)
		container.Slider:SetRange(Min, Max)
		if Current then container.Slider:SetPosition(Current) end
	end
	container.SetText = container.Label.SetText
	--container.SetWidth = container.Slider.SetWidth
	function container:SetSliderXOffset(Offset)
		if Offset == container.SliderXOffset then return end
		container.Slider:ClearPoint("TOPLEFT") -- cannot be ClearAll
		container.Slider:SetPoint("TOPLEFT", container.Label, "TOPRIGHT", Offset, 0)
		container.SliderXOffset = Offset
		container:Resize()
	end
	function container:Resize()
		container:SetWidth(container.Label:GetWidth() + container.SliderXOffset + container.Slider:GetWidth())
		local height = math.max(container.Label:GetHeight(), container.Slider:GetHeight())
		container:SetHeight(height)
	end
	function container:GetPosition()
		return container.Slider:GetPosition()
	end
	function container:SetPosition(Position, Silent)
		container.Slider:SetPosition(Position, Silent)
	end
	function container:SetLabelText(Text)
		container.Label:SetText(Text)
	end

	if Label then container.Label:SetText(Label) end
	
	container:Resize()
	
	return container
end