local TOC, CCD = ...
CCD.UI = CCD.UI or {}
CCD.UI.FrameTextEffectGlow = {
	colorA = 1, colorB = 0, colorG = 0, colorR = 0,
	offsetX = 0, offsetY = 0,
	blurX = 2, blurY = 2, -- Range: 0 - 2; 0 has no outline while 2 has a very strong outline
	knockout = false,
	replace = false,
	strength = 10 -- Range: 1 - 10; I don't see a difference
}
CCD.UI.DefaultTextEffectGlow = {
	colorA = 0.8, colorB = 0, colorG = 0, colorR = 0,
	offsetX = 0, offsetY = 0,
	blurX = 1, blurY = 1,
	knockout = false,
	replace = false,
	strength = 3
}


function CCD.UI.CreateText(Name, Parent)
	local text = UI.CreateFrame("Text", Name, Parent)

	text:SetFontSize(15)
	text:SetWordwrap(true)
	text:SetVisible(true)

	text.BaseSetText = text.SetText
	function text:SetText(Text, Size, Color)
		text:BaseSetText(Text)
		if Size then text:SetFontSize(Size) end
		if Color then text:SetFontColor(Color.R, Color.G, Color.B) end
	end
	function text:SetHTMLText(Text)
		text:BaseSetText(Text, true)
	end
	text.BaseSetFontColor = text.SetFontColor
	function text:SetFontColor(Color, Green, Blue, Alpha)
		if Green then
			text:BaseSetFontColor(Color, Green, Blue, Alpha or 1)
		else
			text:BaseSetFontColor(Color.R, Color.G, Color.B, Color.A)
		end
	end
	function text:SetSize(W, H)
		self:SetWidth(W)
		self:SetHeight(H or W)
	end
	function text:Show()
		text:SetVisible(true)
	end
	function text:Hide()
		text:SetVisible(false)
	end
	
	text.BaseSetBackgroundColor = text.SetBackgroundColor
	function text:SetBackgroundColor(Color, Green, Blue, Alpha)
		if Green then
			text:BaseSetBackgroundColor(Color, Green, Blue, Alpha or 1)
		else
			text:BaseSetBackgroundColor(Color.R, Color.G, Color.B, Color.A)
		end
	end
	function text:SetBackgroundAlpha(Alpha)
		local r, g, b, a = self:GetBackgroundColor()
		self.SetBackgroundColor(self, r, g, b, Alpha)
	end
	return text
end
