local TOC, CCD = ...
CCD.UI = CCD.UI or {}

function CCD.UI.CreateTextField(Name, Parent, LeadingText, TrailingText)
	-- Container
	local container = CCD.UI.CreateFrame(Name, Parent)
	--Library.LibSimpleWidgets.SetBorder("plain", container, 1, 1, 1, 1, 1, "tblr") -- thin white border
	
	-- Leading Text
	container.Label = CCD.UI.CreateText(Name .. ".Label", container)
	container.Label:SetText(LeadingText, 15, CCD.UI.Color.White())
	container.Label:SetPoint("TOPLEFT", container, "TOPLEFT")
	container.Label:Show()

	-- EnKai Text Field
	container.TextField = EnKai.uiCreateFrame("nkTextField", Name .. ".TextField", container)
	container.TextField:SetValue("valueType", "number")
	container.TextField:SetPoint("TOPLEFT", container.Label, "TOPRIGHT", 5, 0)
	container.TextField:SetVisible(true)
	function container.TextField:SetTextFieldChangedEvent() end -- to be removed
	
	-- Trailing Text
	container.Label2 = CCD.UI.CreateText(Name .. ".Label2", container)
	
	if TrailingText then		
		container.Label2:SetText(TrailingText, 15, CCD.UI.Color.White())
		container.Label2:SetPoint("TOPLEFT", container.TextField, "TOPRIGHT", 3, 0)
		container.Label2:Show()
		container:SetSize(container.Label:GetWidth() + 5 + container.TextField:GetWidth() + 3 + container.Label2:GetWidth(), container.Label:GetHeight())
	else
		container:SetSize(container.Label:GetWidth() + 5 + container.TextField:GetWidth(), container.Label:GetHeight())
	end	
	
	function container:SetFontSize(FontSize)
		container.Label:SetFontSize(FontSize)
		if TrailingText then container.Label2:SetFontSize(FontSize) end
		container:RecalculateDimensions()
	end
	function container:SetTextFieldWidth(Width)
		container.TextField:SetWidth(Width)
		container:RecalculateDimensions()
	end
	function container:SetLabel1(Text)
		container.Label:SetText(Text)
		container:RecalculateDimensions()
	end
	function container:SetLabel2(Text)
		container.Label2:SetText(Text)
		container:RecalculateDimensions()
	end
	function container:RecalculateDimensions()
		container:SetWidth(container.Label:GetWidth() + 5 + container.TextField:GetWidth() + 2 + container.Label2:GetWidth())
		container:SetHeight(math.max(container.Label:GetHeight(), container.TextField:GetHeight(), container.Label2:GetHeight()))
	end
	function container:SetTextField(Text)
		container.TextField:SetText(Text)
	end
	function container:SetTextFieldChangedEvent(EventHandler, EventHandlerId)
		local name = container.TextField:GetName()
		Command.Event.Attach(EnKai.events[name].TextfieldChanged, EventHandler, EventHandlerId)
	end
	function container:GetConvertedText()
		return container.TextField:GetConvertedText()
	end
		
	return container
end
